'''
################################################
#  Rummy.py - card class and helper functions  #
################################################
'''

import card

def encode_card(card):
	try:
		encoded_card = '%d-%d' % (card.suit, card.face)
		return encoded_card
	except:
		return False

def decode_card(encoded_card):
	import re
	card_re = re.compile('^(\d{1})-(\d{2})$')
	try:
		suit, face = card_re.findall(encoded_card)[0]
		card = Card( int(suit), int(face) )
		return card
	except IndexError:
		return False
	except ValueError:
		return False

class Card:
	def __init__ (self, suit, face):
		self.suit = suit
		self.face = face
		
	def GetValue(self):
		# A
		if self.face == 0:
			return 20
			
		# 2
		elif self.face == 1:
			return 40
			
		# 3 - 9
		elif (self.face >= 2 and self.face <= 8):
			return 5
		
		# 10, J, Q, K
		elif (self.face >= 9 and self.face <= 12):
			return 10
	
	def humanize(self):
		suits = ['Spades', 'Clubs', 'Hearts', 'Diamonds']
		faces = ['Ace'] + range(2,11) + ['Jack','Queen','King']
		
		return "%s of %s" % (faces[self.face], suits[self.suit])