'''
#####################
#  Rummy.py Client  #
#####################
'''
from card import *
from talk import *

import socket
from time import sleep

# DEFAULT SETTINGS

BUFFER_SIZE = 100
#MAX_FAILS = 3
TICK = 2

#

class RummyClient:
	def __init__ (self, name):
		self.name = name
		self.sock = None
		
	def ask_go (self):
		
		sleep(TICK)	# Snore...
		
		self.sock.send(ASK_GO)
		
		response = self.sock.recv(BUFFER_SIZE)
		
		if response == MSG_OK:
			return True
		elif response == MSG_FAIL:
			return False
		else:
			print "Unexpected response from server."
		
	def end_turn (self):
		self.sock.send(ACT_END)
		response = self.sock.recv(BUFFER_SIZE)
		
		return (response == MSG_OK)
	
	def connect (self, addr, port):
		self.sock = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
		self.sock.connect( (addr, port) )
		
		self.sock.send(self.name)
		response = self.sock.recv(BUFFER_SIZE)
		
		return (response == MSG_OK)